<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\ContractModelService;
use SM\Traits\TResponse;

class ContractModelController extends SMCrud
{
    use TResponse;

    protected $ContractModelService;

    public function __construct($crudService, $environment, ContractModelService $ContractModelService)
    {
        parent::__construct($crudService, $environment);
        $this->ContractModelService = $ContractModelService;
    }

    public function getContractModel(Request $request)
    {
        try {
            $data = $this->ContractModelService->getContractModel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTabEscopoFaturamento(Request $request)
    {
        try {
            $data = $this->ContractModelService->getTabEscopoFaturamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTabModeloDocumento(Request $request)
    {
        try {
            $data = $this->ContractModelService->getTabModeloDocumento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTabPerfisAcesso(Request $request)
    {
        try {
            $data = $this->ContractModelService->getTabPerfisAcesso($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getTabSignatariosPadroes(Request $request)
    {
        try {
            $data = $this->ContractModelService->getTabSignatariosPadroes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveModalAddContractModel(Request $request)
    {
        try {
            $data = $this->ContractModelService->saveModalAddContractModel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteContractModel(Request $request)
    {
        try {
            $data = $this->ContractModelService->deleteContractModel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteContractModelTabEscopoFaturamento(Request $request)
    {
        try {
            $data = $this->ContractModelService->deleteContractModelTabEscopoFaturamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteContractModelTabModeloDocumento(Request $request)
    {
        try {
            $data = $this->ContractModelService->deleteContractModelTabModeloDocumento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteContractModelTabPerfisAcesso(Request $request)
    {
        try {
            $data = $this->ContractModelService->deleteContractModelTabPerfisAcesso($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteContractModelTabSignatariosPadroes(Request $request)
    {
        try {
            $data = $this->ContractModelService->deleteContractModelTabSignatariosPadroes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getEscopoDeFaturamento()
    {
        try {
            $data = $this->ContractModelService->getEscopoDeFaturamento();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveModalAddContractModelTabEscopoFaturamento(Request $request)
    {
        try {
            $data = $this->ContractModelService->saveModalAddContractModelTabEscopoFaturamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveModalAddContractModelTabModeloDocumento(Request $request)
    {
        try {
            $data = $this->ContractModelService->saveModalAddContractModelTabModeloDocumento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveModalAddContractModelTabPerfisAcesso(Request $request)
    {
        try {
            $data = $this->ContractModelService->saveModalAddContractModelTabPerfisAcesso($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveModalAddContractModelTabSignatariosPadroes(Request $request)
    {
        try {
            $data = $this->ContractModelService->saveModalAddContractModelTabSignatariosPadroes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getModeloDeDocumento()
    {
        try {
            $data = $this->ContractModelService->getModeloDeDocumento();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getPerfisDeAcesso()
    {
        try {
            $data = $this->ContractModelService->getPerfisDeAcesso();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getSignatariosContractModel()
    {
        try {
            $data = $this->ContractModelService->getSignatariosContractModel();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getOperadoresContractModel()
    {
        try {
            $data = $this->ContractModelService->getOperadoresContractModel();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getCpfSignatario(Request $request)
    {
        try {
            $data = $this->ContractModelService->getCpfSignatario($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function editContractModelTabModeloDocumento(Request $request)
    {
        try {
            $data = $this->ContractModelService->editContractModelTabModeloDocumento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function editContractModelTabSignatariosPadroes(Request $request)
    {
        try {
            $data = $this->ContractModelService->editContractModelTabSignatariosPadroes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function editContractModel(Request $request)
    {
        try {
            $data = $this->ContractModelService->editContractModel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }
}