<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\LogCallbackCertisignService;
use SM\Traits\TResponse;

class LogCallbackCertisignController extends SMCrud
{

    use TResponse;

    protected $LogCallbackCertisignService;

    public function __construct($crudService, $environment, LogCallbackCertisignService $LogCallbackCertisignService)
    {
            parent::__construct($crudService, $environment);
            $this->LogCallbackCertisignService = $LogCallbackCertisignService;
    }

    public function exmploPadrao(DTO\Request $request, DTO\Response $response)
    {
        $chart = $this->DashboardService->getRenegotiatedContracts($request->getParameters());
        $dtsVal = new DataSet('chart', $chart);
        $response->addDataSet($dtsVal);
    }

    public function logCallbackCertisign()
    {
        try {
            $data = $this->LogCallbackCertisignService->logCallbackCertisign();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getProposal()
    {
        try {
            $data = $this->LogCallbackCertisignService->getProposal();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getContractsLog()
    {
        try {
            $data = $this->LogCallbackCertisignService->getContractsLog();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
